// next_permutation.cpp
// compile with: /EHsc
// Illustrates how to use the next_permutation function.
//
// Functions:
//    next_permutation : Change the order of the sequence to the
//                       next lexicograhic permutation.

// disable warning C4786: symbol greater than 255 character,
// okay to ignore
//#pragma warning(disable: 4786)

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <functional>

using namespace std ;

int main()
{
    const int VECTOR_SIZE = 3 ;

    // Define a template class vector of strings
    typedef vector<int> IntVector ;

    //Define an iterator for template class vector of strings
    typedef IntVector::iterator IntVectorIt ;


    IntVector Pattern(VECTOR_SIZE) ;

    IntVectorIt start, end, it ;


    start = Pattern.begin() ;   // location of first
                                // element of Pattern

    end = Pattern.end() ;       // one past the location last
                                // element of Pattern

    //Initialize vector Pattern
    Pattern[0] = 0 ;
    Pattern[1] = 1 ;
    Pattern[2] = 2 ;

    // print content of Pattern
    cout << "Before calling next_permutation:\n" << "Pattern: " ;
    for(it = start; it != end; it++)
        cout << *it << " " ;
    cout << "\n\n" ;

    // Generate all possible permutations

    cout << "After calling next_permutation:" << endl ;
    while ( next_permutation(start, end) )
    {
		for(it = start; it != end; it++)
			cout << *it << " " ;
        cout << endl ;
    }
}